/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Autorizacion;
import com.rjconsultores.ventaboletos.entidad.AutorizacionPerfil;
import com.rjconsultores.ventaboletos.entidad.Perfil;
import com.rjconsultores.ventaboletos.service.AutorizacionPerfilService;
import com.rjconsultores.ventaboletos.service.AutorizacionService;
import com.rjconsultores.ventaboletos.service.PerfilService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;

/**
 *
 * @author Administrador
 */
@Controller("editarAutorizacionPerfilController")
@Scope("prototype")
public class EditarAutorizacionPerfilController extends MyGenericForwardComposer {

    @Autowired
    private AutorizacionPerfilService autorizacionPerfilService;
    @Autowired
    private PerfilService perfilService;
    @Autowired
    private AutorizacionService autorizacionService;
    private List<Autorizacion> lsAutorizacion;
    private List<Perfil> lsPerfil;
    private AutorizacionPerfil autorizacionPerfil;
    private MyListbox autorizacionPerfilList;
    private Combobox cmbPerfil;
    private Combobox cmbAutorizacion;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarAutorizacionPerfilController.class);

    public AutorizacionPerfil getAutorizacionPerfil() {
        return autorizacionPerfil;
    }

    public void setAutorizacionPerfil(AutorizacionPerfil autorizacionPerfil) {
        this.autorizacionPerfil = autorizacionPerfil;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Combobox getCmbAutorizacion() {
        return cmbAutorizacion;
    }

    public void setCmbAutorizacion(Combobox cmbAutorizacion) {
        this.cmbAutorizacion = cmbAutorizacion;
    }

    public Combobox getCmbPerfil() {
        return cmbPerfil;
    }

    public void setCmbPerfil(Combobox cmbPerfil) {
        this.cmbPerfil = cmbPerfil;
    }

    public List<Autorizacion> getLsAutorizacion() {
        return lsAutorizacion;
    }

    public void setLsAutorizacion(List<Autorizacion> lsAutorizacion) {
        this.lsAutorizacion = lsAutorizacion;
    }

    public List<Perfil> getLsPerfil() {
        return lsPerfil;
    }

    public void setLsPerfil(List<Perfil> lsPerfil) {
        this.lsPerfil = lsPerfil;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsAutorizacion = autorizacionService.obtenerTodos();
        lsPerfil = perfilService.obtenerTodos();

        super.doAfterCompose(comp);

        autorizacionPerfil = (AutorizacionPerfil) Executions.getCurrent().getArg().get("autorizacionPerfil");
        autorizacionPerfilList = (MyListbox) Executions.getCurrent().getArg().get("autorizacionPerfilList");

        if (autorizacionPerfil.getAutorizacionperfilId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        cmbAutorizacion.focus();
    }

    public void onClick$btnSalvar(Event ev) {
        cmbPerfil.getSelectedItem();
        cmbAutorizacion.getSelectedItem();

        try {
            autorizacionPerfil.setActivo(Boolean.TRUE);
            autorizacionPerfil.setFecmodif(Calendar.getInstance().getTime());
            autorizacionPerfil.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<AutorizacionPerfil> lsAutoriazacionPerfil =
                    autorizacionPerfilService.buscar(autorizacionPerfil.getAutorizacion(),
                    autorizacionPerfil.getPerfil());

            if (!lsAutoriazacionPerfil.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarAutorizacionPerfilController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (autorizacionPerfil.getAutorizacionperfilId() == null) {
                    autorizacionPerfilService.suscribir(autorizacionPerfil);
                    autorizacionPerfilList.addItem(autorizacionPerfil);
                } else {
                    autorizacionPerfilService.actualizacion(autorizacionPerfil);
                    autorizacionPerfilList.updateItem(autorizacionPerfil);
                }

                Messagebox.show(
                        Labels.getLabel("editarAutorizacionPerfilController.MSG.suscribirOK"),
                        Labels.getLabel("editarAutorizacionPerfilController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarAutorizacionPerfilController.MSG.borrarPergunta"),
                    Labels.getLabel("editarAutorizacionPerfilController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                autorizacionPerfilService.borrar(autorizacionPerfil);

                Messagebox.show(
                        Labels.getLabel("editarAutorizacionPerfilController.MSG.borrarOK"),
                        Labels.getLabel("editarAutorizacionPerfilController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                autorizacionPerfilList.removeItem(autorizacionPerfil);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
